#ifndef COMPONENTVIEW_H
#define COMPONENTVIEW_H

#include <qwidget.h>
#include <qscrollview.h>
#include <qcursor.h>

#include <string>
#include <list>
using namespace std;

class QPainter;
//class QCursor;

#include "coord.h"
#include "complib.h"


class SComponentView: public QScrollView
{
    Q_OBJECT

public:
	SComponentView(QWidget* parent,bool lcomode);	//󥹥ȥ饯
	~SComponentView();								//ǥȥ饯
	
	//ɽ˴ؤ
	void RefreshView(){viewport()->update();}
	
	//
	void setComponentIndex(const SCompIndex* pComponentIndex);
	void setBlock(int block);
	int  cursorLTRB(){ return m_cursorLTRB; }
	int  cursorOffset(){ return m_cursorOffset; }

protected:
	const SCompIndex* m_pComponentIndex;
	
	bool m_bLcoMode;
	int  m_block;
	int  m_cursorLTRB;
	int  m_cursorOffset;

protected:
	QSize getContentsSize();	//ӥ塼ΥƥĤΥ
	SPoint pinEndPos(int ltrb,int offset);	//LTRBOffsetǼɸºݤΥԥüɸ
	void drawFrame(QPainter*p,const SRect* prcClip);
	void drawCursor(QPainter*p,const SRect* prcClip);

signals:
	void cursorMoved();
	//void toolChange();

private slots:

protected:
	void contentsMousePressEvent(QMouseEvent*);
//	void contentsMouseReleaseEvent(QMouseEvent *);
//	void contentsMouseMoveEvent(QMouseEvent *me);
	void drawContents(QPainter*p,int clipx,int clipy, int clipw, int cliph );	//
	void viewportResizeEvent(QResizeEvent * );
};


#endif