// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef SETLIB_H
#define SETLIB_H
#include "setlib.h"

class QStringList;

class SetLib : public SetLibBase
{ 
    Q_OBJECT

protected:
	QStringList m_files;

public:
    SetLib( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~SetLib();
	int exec();
	void setFiles(const QStringList& files);
	QStringList selectedFiles();

public:
    void OnAddButton();
    void OnDownButton();
    void OnUpButton();
    void itemChanged();
    void OnRemoveButton();
	void setButtonEnable();
protected  slots:
	void accept();

};

#endif // SETLIB_H
