// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
/****************************************************************************
** XBSchǥ饹μ
****************************************************************************/
#include <stdio.h>
//#include <qnamespace.h>
#include "xbschobj.h"


//󥹥ȥ饯
SXBSchObj::SXBSchObj()
{
	m_PlaceNum = 0;					//ֹν
	m_pRefObj = NULL;	//ȥ֥ȤؤΥݥ
	m_Layer = 0;					//֥쥤䡼
	m_Selection = NOT_SELECTED;		//
	m_p1.setX(-1);
	m_p1.setY(-1);
}

//֤ư
void SXBSchObj::move(int offsetx,int offsety)
{
	SPoint p(offsetx,offsety);
	switch(m_Selection & SELECT_ALL){
	case NOT_SELECTED:
	case SELECT_ALL:
		m_p1 += p;
		m_p2 += p;
		break;
	case SELECT_P1:
		m_p1 += p;
		break;
	case SELECT_P2:
		m_p2 += p;
		break;
	}
}	
	
//XɸꤷƺȿžԤ
void SXBSchObj::mirrorH(int x)
{
	m_p1.setX(x*2 -m_p1.x());
	m_p2.setX(x*2 -m_p2.x());
}

//ȿžԤ
void SXBSchObj::mirrorH()
{
	int x= (m_p1.x() + m_p2.x())/2;
	mirrorH(x);
}
	
//XY濴ɸꤷơžԤ
void SXBSchObj::rotate(const SPoint& p)
{
	int newX,newY;
	newY = p.y() + (m_p1.x() - p.x()) ;
	newX = p.x() - (m_p1.y() - p.y()) ;
	m_p1.setY( newY );
	m_p1.setX( newX );

	newY = p.y() + (m_p2.x() - p.x()) ;
	newX = p.x() - (m_p2.y() - p.y()) ;
	m_p2.setY( newY );
	m_p2.setX( newX );
}

//žԤ
void SXBSchObj::rotate()
{
	SPoint p;
	p.setX((m_p1.x()+m_p2.x())/2);
	p.setY((m_p1.y()+m_p2.y())/2);
	rotate(p);
}

//ե饰򥻥åȤ
void  SXBSchObj::setSelection(unsigned sel)
{
	m_Selection = sel;
}

//ե饰ꥻåȤ
void  SXBSchObj::resetSelection()
{
	m_Selection = 0;
}



//prcArea⳰ɤ֤
unsigned SXBSchObj::SetOutCode(const SPoint& p,const SRect& rcArea)
{
	unsigned outcode=0;											//  UL  | U | UR
	if		(p.x() < rcArea.l() )	outcode |= OUTCODE_LEFT;	//  ----+---+----
	else if (p.x() > rcArea.r() )	outcode |= OUTCODE_RIGHT;	//   L  | 0 |  R
	if		(p.y() < rcArea.t() )	outcode |= OUTCODE_UPPER;	//  ----+---+----
	else if	(p.y() > rcArea.b() )	outcode |= OUTCODE_LOWER;	//  LL  | L | LR
	return outcode;
}

//ȶνŤʤ򡢽Ť߾դ֤
int SXBSchObj::PointAndRectMag(const SPoint& p,const SRect& rcArea)
{
	int lp,rp,tp,bp,xp,yp;								//   left						  right
	if(( lp = p.x() - rcArea.l()  )<=0) return 0;	// ---+----------P------------------+----
	if(( rp = rcArea.r() - p.x() )<=0) return 0;	//         lp              rp
	if(( tp = p.y() - rcArea.t()   )<=0) return 0;
	if(( bp = rcArea.b()- p.y() )<=0) return 0;

	if(lp<rp) xp=lp; else xp=rp;						//ο֥ͤåΥƤ͡פȤƻȤ
	if(tp<bp) yp=tp; else yp=bp;
	xp=(xp*16)/(lp+rp);				//ͤϣ
	yp=(yp*16)/(tp+bp);				//ͤϣ
	return (xp*yp)+1;				//ͤϣ
}

