// Copyright (C) 2002-2003 H.Okada(suigyodo) All rights reserved.
#ifdef _WINDOWS
	#include <windows.h>
#endif
#include <string.h>






#include <qimage.h>
#include <qpixmap.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qkeycode.h>
//#include <qmultilineedit.h>
//#include <qfile.h>
#include <qfiledialog.h>
#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qprinter.h>
#include <qapplication.h>
#include <qaccel.h>
#include <qlabel.h>
#include <qtextstream.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qwhatsthis.h>
#include <qscrollview.h>
#include <qtooltip.h>
#include <qfontdialog.h>
#include <qwidgetlist.h>


#include "xbsch.h"
#include "xbschview.h"
#include "application.h"
#include "xbschglobal.h"
#include "cfgdata.h"



#include "filesave.xpm"
#include "fileopen.xpm"
//#include "fileprint.xpm"
#include "toolbent.xpm"
#include "toolbus.xpm"
#include "toolcmnt.xpm"
#include "toolcomp.xpm"
#include "tooldash.xpm"
#include "tooldrag.xpm"
#include "toolent.xpm"
#include "tooljunc.xpm"
#include "toollabel.xpm"
#include "toolselect.xpm"
#include "tooltag.xpm"
#include "toolwire.xpm"
#include "xbschicon.xpm"
#include "setlibimpl.h"

//#include <windows.h>
/* What's this Τʸ󡣤򥵥ݡȤʤ
const char * fileOpenText = "<img source=\"fileopen\"> "
"Click this button to open a <em>new file</em>. <br><br>"
"You can also select the <b>Open command</b> from the File menu.";
const char * fileSaveText = "Click this button to save the file you are "
"editing.  You will be prompted for a file name.\n\n"
"You can also select the Save command from the File menu.\n\n"
"Note that implementing this function is left as an exercise for the reader.";
const char * filePrintText = "Click this button to print the file you "
"are editing.\n\n"
"You can also select the Print command from the File menu.";
*/

//Static Сѿ
QWidgetList ApplicationWindow::m_appWindowList;

//󥹥ȥ饯
ApplicationWindow::ApplicationWindow()
    : QMainWindow( 0, "XBSch Main Window", WDestructiveClose )
{
//    int id;
//	m_pscrollview = NULL;	
//	m_pxbschview = NULL;

//  printer = new QPrinter;

	QFont tipfont( "helvetica", 10 ) ;
	QToolTip::setFont ( tipfont );
	
	setCaption( "Qt BSch" );

	setIcon(QPixmap((const char**)xbschicon ));



	////////////////////////////////////////////////
	//TOOLBARν
	////////////////////////////////////////////////
	QPixmap openIcon, saveIcon, printIcon,
			tSelectIcon,tDragIcon,tCompIcon,
			tBusIcon,tWireIcon,tDashIcon,
			tJuncIcon,tBEntIcon,tEntIcon,
			tTagIcon,tLabelIcon,tCmntIcon;
	
    toolbar = new QToolBar( this);

   	//toolbar = new QToolBar( this, "file operations" );

    openIcon = QPixmap( (const char**)fileopen );
    m_ptbFileOpen = new QToolButton( openIcon, "Open File", QString::null,
			   this, SLOT(load()), toolbar, "open file" );
	
    saveIcon = QPixmap( (const char**)filesave );
    m_ptbFileSave = new QToolButton( saveIcon, "Save File", QString::null,
			   this, SLOT(save()), toolbar, "save file" );

    //printIcon = QPixmap( (const char**)fileprint );
    //m_ptbFilePrint = new QToolButton( printIcon, "Print File", QString::null,
	//		   this, SLOT(print()), toolbar, "print file" );
	m_ptbFilePrint = NULL;	

	toolbar->addSeparator();
	
   	//toolbar = new QToolBar( this);
 	

	tSelectIcon = QPixmap( (const char**) toolselect );
    m_ptbToolSelect = new QToolButton( tSelectIcon, "Select", QString::null,
			   this, SLOT(ToolSelector()), toolbar, "Select" );
	m_ptbToolSelect->setToggleButton (true);


	tDragIcon = QPixmap( (const char**) tooldrag );
    m_ptbToolDrag = new QToolButton( tDragIcon, "Drag", QString::null,
			   this, SLOT(ToolDrag()), toolbar, "Drag" );
	m_ptbToolDrag->setToggleButton (true);

	toolbar->addSeparator();

	tCompIcon = QPixmap( (const char**) toolcomp );
    m_ptbToolComp = new QToolButton( tCompIcon, "Component", QString::null,
			   this, SLOT(ToolComp()), toolbar, "Component" );
	m_ptbToolComp->setToggleButton (true);

	toolbar->addSeparator();

	tBusIcon = QPixmap( (const char**) toolbus );
    m_ptbToolBus = new QToolButton( tBusIcon, "Bus", QString::null,
			   this, SLOT(ToolBus()), toolbar, "Bus" );
	m_ptbToolBus->setToggleButton (true);

	tWireIcon = QPixmap( (const char**) toolwire );
    m_ptbToolWire= new QToolButton( tWireIcon, "Wire", QString::null,
			   this, SLOT(ToolWire()), toolbar, "Wire" );
	m_ptbToolWire->setToggleButton (true);

	tDashIcon = QPixmap( (const char**) tooldash );
    m_ptbToolDash = new QToolButton( tDashIcon, "Dash", QString::null,
			   this, SLOT(ToolDash()), toolbar, "Dash" );
	m_ptbToolDash->setToggleButton (true);

	toolbar->addSeparator();

	tJuncIcon = QPixmap( (const char**) tooljunc );
    m_ptbToolJunc = new QToolButton( tJuncIcon, "Junction", QString::null,
			   this, SLOT(ToolJunction()), toolbar, "Junction" );
	m_ptbToolJunc->setToggleButton (true);

	tBEntIcon = QPixmap( (const char**) toolbent );
    m_ptbToolBEnt = new QToolButton( tBEntIcon, "Bus Entry", QString::null,
			   this, SLOT(ToolBEntry()), toolbar, "Bus Entry" );
	m_ptbToolBEnt->setToggleButton (true);

	tEntIcon = QPixmap( (const char**) toolent );
    m_ptbToolEnt = new QToolButton( tEntIcon, "Entry", QString::null,
			   this, SLOT(ToolEntry()), toolbar, "Entry" );
	m_ptbToolEnt->setToggleButton (true);

	toolbar->addSeparator();

	tTagIcon = QPixmap( (const char**) tooltag );
    m_ptbToolTag = new QToolButton( tTagIcon, "Tag", QString::null,
			   this, SLOT(ToolTag()), toolbar, "Tag" );
	m_ptbToolTag->setToggleButton (true);

	tLabelIcon = QPixmap( (const char**)toollabel);
    m_ptbToolLabel = new QToolButton( tLabelIcon, "Label", QString::null,
			   this, SLOT(ToolLabel()), toolbar, "Label" );
	m_ptbToolLabel->setToggleButton (true);

	tCmntIcon = QPixmap( (const char**) toolcmnt);
    m_ptbToolCmnt = new QToolButton( tCmntIcon, "Comment", QString::null,
			   this, SLOT(ToolCmnt()), toolbar, "Comment" );
	m_ptbToolCmnt->setToggleButton (true);

	//Qt 2.0 Ǥ draggable toolbar ̤Ǥ
	setDockEnabled(Top,true);
	setDockEnabled(Left,true);
	setDockEnabled(Right,true);
	setDockEnabled(Bottom,true);



/*  
    (void)QWhatsThis::whatsThisButton( toolbar );

    QWhatsThis::add( fileOpen, fileOpenText );
	//What's this HTMLɽȤˤϲιԤɬ
	QMimeSourceFactory::defaultFactory()->setPixmap( "fileopen", openIcon );
    QWhatsThis::add( fileSave, fileSaveText );
    QWhatsThis::add( filePrint, filePrintText );
*/

	////////////////////////////////////////////////////
	//MENUν
	////////////////////////////////////////////////////
	//FILE˥塼
    QPopupMenu * file = new QPopupMenu( this );
    menuBar()->insertItem( "File", file );

	file->insertItem( "New", this, SLOT(newDoc()), CTRL+Key_N );
	file->insertItem( "Open...", this, SLOT(load()), CTRL+Key_O );
   	file->insertItem( "Save...", this, SLOT(save()), CTRL+Key_S );
 	file->insertItem( "Save as...", this, SLOT(saveAs()) );
	file->insertSeparator();
	file->insertItem( "Export image...",this, SLOT(exportImage()) );
 	file->insertSeparator();
	file->insertItem( "Close", this, SLOT(close()));
	file->insertItem( "Quit", qApp, SLOT( closeAllWindows() ));

	//EDIT˥塼
    QPopupMenu * edit = new QPopupMenu( this );
	menuBar()->insertItem( "Edit", edit);
    m_nMenuIdEditUndo = edit->insertItem( "Undo", this, SLOT(EditUndo()), CTRL+Key_Z );
    m_nMenuIdEditCut = edit->insertItem( "Cut", this, SLOT(EditCut()), CTRL+Key_X );
    m_nMenuIdEditCopy = edit->insertItem( "Copy", this, SLOT(EditCopy()), CTRL+Key_C );
    m_nMenuIdEditPaste = edit->insertItem( "Paste", this, SLOT(EditPaste()), CTRL+Key_V );
    m_nMenuIdEditDelete = edit->insertItem( "Delete", this, SLOT(EditDelete()));
    edit->insertSeparator();
   m_nMenuIdEditAttr = edit->insertItem( "Attribute", this, SLOT(EditAttr()), CTRL+Key_A );
    m_nMenuIdEditMirror = edit->insertItem( "Mirror", this, SLOT(EditMirror()), CTRL+Key_M );
    m_nMenuIdEditRotate = edit->insertItem( "Rotate", this, SLOT(EditRotate()), CTRL+Key_R );
	//m_nMenuIdEditInvert = edit->insertItem( "&Invert", this, SLOT(EditInvert()), CTRL+Key_I );


	//VIEW˥塼
    QPopupMenu * view = new QPopupMenu( this );
    menuBar()->insertItem( "View", view);
    view->insertItem( "Refresh", this, SLOT(ViewRefresh()) );
    view->insertSeparator();
    m_nMenuIdViewZoomIn = view->insertItem( "Zoom  In", this, SLOT(ViewZoomIn()));//, Key_PageUp );
    m_nMenuIdViewZoomOut = view->insertItem( "Zoom  Out", this, SLOT(ViewZoomOut()));//, Key_PageDown );
    view->insertSeparator();
    m_nMenuIdViewGrid = view->insertItem( "Grid", this, SLOT(ViewGridOnOff()));


	//TOOL˥塼
    QPopupMenu * tools = new QPopupMenu( this );
    menuBar()->insertItem( "Tool", tools);
    m_nMenuIdToolSelect = tools->insertItem( "Select", this, SLOT(ToolSelector()),Key_Escape );
    m_nMenuIdToolDrag = tools->insertItem( "Drag", this, SLOT(ToolDrag()) );
    tools->insertSeparator();
    m_nMenuIdToolComp = tools->insertItem( "Component", this, SLOT(ToolComp()) );
    tools->insertSeparator();
    m_nMenuIdToolBus = tools->insertItem( "Bus", this, SLOT(ToolBus()) );
    m_nMenuIdToolWire = tools->insertItem( "Wire", this, SLOT(ToolWire()) );
    m_nMenuIdToolDash = tools->insertItem( "Dash", this, SLOT(ToolDash()) );
    tools->insertSeparator();
    m_nMenuIdToolJunc = tools->insertItem( "Junction", this, SLOT(ToolJunction()) );
    m_nMenuIdToolBEnt = tools->insertItem( "Bus entry", this, SLOT(ToolBEntry()) );
    m_nMenuIdToolEnt = tools->insertItem( "Entry", this, SLOT(ToolEntry()) );
    tools->insertSeparator();
    m_nMenuIdToolTag = tools->insertItem( "Tag", this, SLOT(ToolTag()) );
    m_nMenuIdToolLabel = tools->insertItem( "Lable", this, SLOT(ToolLabel()) );
    m_nMenuIdToolCmnt = tools->insertItem( "Comment", this, SLOT(ToolCmnt()) );


	//SET˥塼
    QPopupMenu * setenv = new QPopupMenu( this );
    menuBar()->insertItem( "Set", setenv);
    setenv->insertItem( "SheetSize...", this, SLOT(SetSheetSize()) );
    m_nMenuIdSetSnap = setenv->insertItem( "Sna&p", this, SLOT(SetSnap()) );
    setenv->insertSeparator();
    setenv->insertItem( "Library...", this, SLOT(SetLibrary()) );
    setenv->insertItem( "default Font...", this, SLOT(SetFont()) );
	
	//WINDOW˥塼
	m_menuWindow = new  QPopupMenu( this );
	menuBar()->insertItem( "Window", m_menuWindow);
	QObject::connect(m_menuWindow,SIGNAL(aboutToShow ()),
			this,SLOT(setupWindowMenu()));
	QObject::connect(m_menuWindow,SIGNAL(activated (int)),
			this,SLOT(selectActiveDocument(int)));
	
	//HELP˥塼
    QPopupMenu * help = new QPopupMenu( this );
    menuBar()->insertSeparator();
    menuBar()->insertItem( "Help", help );

    help->insertItem( "About Qt-BSch", this, SLOT(about()));
    help->insertItem( "About&Qt", this, SLOT(aboutQt()));

/*  
	help->insertSeparator();
    help->insertItem( "What's &This", this, SLOT(whatsThis()), SHIFT+Key_F1);
*/

    m_pXBSchView = new SXBSchView(this);
    setCentralWidget(m_pXBSchView);

	QObject::connect(m_pXBSchView,SIGNAL(cursorMove(int,int)),
					this,SLOT(cursorMove(int,int)));

	QObject::connect(m_pXBSchView,SIGNAL(toolChange()),
					this,SLOT(toolChange()));


	int nCfg1;
//	int nCfg2;
	//åɽ̵ͭ
	if(!g_cfg.getInt("VIEW","GRID",nCfg1)){
		g_cfg.setInt("VIEW","GRID",1);
		nCfg1=1;
	}
	m_pXBSchView->setDisplayGrid(nCfg1!=0);
	menuBar()->setItemChecked(m_nMenuIdViewGrid,nCfg1!=0);

	//ʥåפξ֤
	if(!g_cfg.getInt("SET","SNAP",nCfg1)){
		g_cfg.setInt("SET","SNAP",1);
		nCfg1=1;
	}
	m_pXBSchView->setSnapGrid(nCfg1!=0);
	menuBar()->setItemChecked(m_nMenuIdSetSnap,nCfg1!=0);




	//ġ⡼ɤ
	m_pXBSchView->setToolMode(TOOL_SELECTOR);
	


	SetToolButtonState();


   	//msg = new QLabel( statusBar(), "message" );
    //msg->setAlignment( AlignCenter );
    //QFont boldfont; boldfont.setWeight(QFont::Bold);
    //msg->setFont( boldfont );
    //statusBar()->addWidget( msg, 4 );


	m_plabelX = new QLabel(" X:0000 ",statusBar());
	m_plabelY = new QLabel(" Y:0000 ",statusBar());
	//QFont statusfont( "helvetica", 10 ) ;
	m_plabelX->setFont( tipfont );
	m_plabelY->setFont( tipfont );
	//m_plabelX->setAlignment(AlignCenter);
	//m_plabelY->setAlignment(AlignCenter);
	statusBar()->addWidget(m_plabelX,0,true);
	statusBar()->addWidget(m_plabelY,0,true);

	//statusBar()->setSizeGripEnabled(false); 

    //statusBar()->message( "Ready", 2000 );
    resize( 600, 450 );

	//¾Υ˥塼ξ֤
	menuBar()->setItemEnabled(m_nMenuIdViewZoomIn,m_pXBSchView->CanZoomIn());
	menuBar()->setItemEnabled(m_nMenuIdViewZoomOut,m_pXBSchView->CanZoomOut());

	m_appWindowList.append(this);
	menuBar()->show();
	//m_filename=("Untitled");
}


ApplicationWindow::~ApplicationWindow()
{
	int windowCount=m_appWindowList.count();
	int n;
	for(n=0;n<windowCount;n++){
		QWidget * w = m_appWindowList.at(n);
		if(w==this){
			m_appWindowList.remove(n);
			break;
		}
    }
	
	
    //delete printer;
}

QString ApplicationWindow::fileName()
{
	return m_filename;
}


bool ApplicationWindow::isEmptyDocWindow()
{
	return  m_filename.isEmpty() && m_pXBSchView->isEmpty();
}

ApplicationWindow* ApplicationWindow::firstEmptyDocWindow()
{
	int windowCount=m_appWindowList.count();
	int n;
	for(n=0;n<windowCount;n++){
		ApplicationWindow * w = (ApplicationWindow*)m_appWindowList.at(n);
		if(w->isEmptyDocWindow())return w;
	}
	return NULL;
}

void ApplicationWindow::newDoc()
{
    ApplicationWindow *ed = new ApplicationWindow;
    ed->show();
}

void ApplicationWindow::load()
{
/*
	if(m_pXBSchView->isDirty()){
		switch( QMessageBox::information( this, "Open",
				      "The current document has been changed since the last save.",
				      "Save Now", "Leave Anyway", "Cancel",
				      0, 2) ) {
		case 0:
			if(save() != 0)	return;			
			break;
    	case 1:
			break;
    	case 2:
    	default:
			return;
    	}
	}

*/

	QString fn = QFileDialog::getOpenFileName( QString::null,"*.ce3",this);
	if ( !fn.isEmpty() ){
		//		if(m_pXBSchView->isDirty()|| !m_pXBSchView->isEmpty()){
		ApplicationWindow * aw =ApplicationWindow::firstEmptyDocWindow();
		if(aw == NULL) aw = new ApplicationWindow();
		aw->show();
		aw->load(fn);
		aw->setActiveWindow();
	    //ApplicationWindow *ed = new ApplicationWindow;
    	//ed->show();
		//ed->load(fn);
//		if(!m_pXBSchView->isDirty()&& m_pXBSchView->isEmpty()){
//			close();
//		}
//		}else{
//			load(fn);
//		}
/*		switch (m_pXBSchView->load(fn)){
		case 0:
			filename = fn;
			setAppCaption();
			break;
		default:
		
		break;
		}
*/
	}else{
		statusBar()->message( "Loading aborted", 2000 );
	}
}

void ApplicationWindow::load(const QString &fn)
//void ApplicationWindow::load( const char *fn)
{
    //QFile f( fn );
	QString msg;
    if(!QFile::exists(fn)) return;
	switch (m_pXBSchView->load(fn)){
	case 0:
		m_filename = fn;
		setAppCaption();
		break;
	case 1:
		msg=fn;
		msg += " read error.";
		QMessageBox::information( this, "Open file",msg,"OK",QString::null,QString::null,0,0);
		break;
	default:
		msg=fn;
		msg += " is not Qt-BSch document.";
		QMessageBox::information( this, "Open file",msg,"OK",QString::null,QString::null,0,0);
		break;
	}
    //QString s;
    //s.sprintf( "Loaded document %s", fileName );
    //statusBar()->message( s, 2000 );
}

//¸0֤
int ApplicationWindow::save()
{
	if ( m_filename.isEmpty() ) {
		return saveAs();
	}else{
		return m_pXBSchView->save(m_filename);
	}
}


//¸0֤
int ApplicationWindow::saveAs()
{
	QString fn = QFileDialog::getSaveFileName( QString::null,"*.ce3",this );
	if ( !fn.isEmpty() ) {
		//ĥҤ̵϶Ū.ce3Ȥ롣
		QFileInfo finfo(fn);
		if(finfo.extension(false).isEmpty()){	//xxxx.פȡxxxxפξĥҤʤȽꤷƤޤ
			if(fn.right(1)!=".") fn+=".";		// Ǹʸ.פǤʤС.פɲá
			fn+="ce3";							// ĥҤɲá
		}
		if(QFile::exists (fn)){
			QString msg=fn;
			msg += " already exists.Overwrite?";
			switch( QMessageBox::information( this, "Save as",msg,
				      "Overwrite", "Cancel",QString::null,0, 1) ) {
			case 0:
				if(m_pXBSchView->save(fn) == 0){
					m_filename = fn;
					setAppCaption();
					return 0;
				}else{
					return 1;
				}			
   			case 1:
			default:
				return 1;
   			}

		}else{
			if(m_pXBSchView->save(fn) == 0){
				m_filename = fn;
				setAppCaption();
				return 0;
			}else{
				return 1;
			}			
		}
	}else{
		return 1;
	}
}

void ApplicationWindow::exportImage()
{
	//qDebug("ApplicationWindow::exportImage()");
	QString imagefilename = m_filename;
	if ( imagefilename.isEmpty() ) {
		imagefilename="untitled";
	}
	QFileInfo finfo(imagefilename);
	QString path=finfo.dirPath(true);
	QString baseName = finfo.baseName(); 
	QString filter;
	//qDebug("dir:%s",path.latin1());
	//qDebug("baseName:%s",baseName.latin1());
	if(!path.isEmpty()) path+='/';
	path+=baseName;

#ifdef _WINDOWS
	path+=".bmp";
	filter="*.bmp";
#else
	path+=".png";
	filter="*.png";
#endif
	QString fn = QFileDialog::getSaveFileName(path,filter,this );
	if(!fn.isEmpty()){
#ifndef _WINDOWS
		//ĥҤ̵϶Ū.pngȤ롣
		QFileInfo finfo(fn);
		if(finfo.extension(false).isEmpty()){	//xxxx.פȡxxxxפξĥҤʤȽꤷƤޤ
			if(fn.right(1)!=".") fn+=".";		// Ǹʸ.פǤʤС.פɲá
			fn+="png";							// ĥҤɲá
		}
#endif
		m_pXBSchView->exportImage(fn);
	}
}

void ApplicationWindow::print()
{
/*
    const int Margin = 10;
    int pageNo = 1;

    if ( printer->setup(this) ) {		// printer dialog
	statusBar()->message( "Printing..." );
	QPainter p;
	p.begin( printer );			// paint on printer
	p.setFont( e->font() );
	int yPos	= 0;			// y position for each line
	QFontMetrics fm = p.fontMetrics();
	QPaintDeviceMetrics metrics( printer ); // need width/height
						// of printer surface
	for( int i = 0 ; i < e->numLines() ; i++ ) {
	    if ( Margin + yPos > metrics.height() - Margin ) {
		QString msg( "Printing (page " );
		msg += QString::number( ++pageNo );
		msg += ")...";
		statusBar()->message( msg );
		printer->newPage();		// no more room on this page
		yPos = 0;			// back to top of page
	    }
	    p.drawText( Margin, Margin + yPos,
			metrics.width(), fm.lineSpacing(),
			ExpandTabs | DontClip,
			e->textLine( i ) );
	    yPos = yPos + fm.lineSpacing();
	}
	p.end();				// send job to printer
	statusBar()->message( "Printing completed", 2000 );
    } else {
	statusBar()->message( "Printing aborted", 2000 );
    }
*/
}

void ApplicationWindow::keyPressEvent ( QKeyEvent * e )
{

	switch(e->key()){
	case Key_Q:
	case Key_PageUp:
		ZoomIn(false);
		break;
	case Key_A:
	case Key_PageDown:
		ZoomOut(false);
		break;
	case Key_S:
		ToolSelector();
		break;
	case Key_R:
		ToolDrag();
		break;
	case Key_P:
		ToolComp();
		break;
	case Key_B:
		ToolBus();
		break;
	case Key_W:
		ToolWire();
		break;
	case Key_D:
		ToolDash();
		break;
	case Key_J:
		ToolJunction();
		break;
	case Key_N:
		ToolBEntry();
		break;
	case Key_E:
		ToolEntry();
		break;
	case Key_T:
		ToolTag();
		break;
	case Key_L:
		ToolLabel();
		break;
	case Key_C:
		ToolCmnt();
		break;
	}

}


void ApplicationWindow::closeEvent( QCloseEvent* ce )
{
	if(m_pXBSchView->isDirty()){
		switch( QMessageBox::information( this, "Close Qt-BSch document",
				      "The current document has been changed since the last save.",
				      "Save Now", "Leave Anyway", "Cancel",
				      0, 2) ) {
		case 0:
			if(save() == 0){
				ce->accept();
			}else{
				ce->ignore();
			}			
			break;
    	case 1:
			ce->accept();
			break;
    	case 2:
    	default:
			ce->ignore();
			break;
    	}
	}else{
		ce->accept();
	}	
}


void ApplicationWindow::about()
{
	QPixmap icon( (const char**)xbschicon );

	QMessageBox mb(this);

	mb.setMinimumWidth(400);
	mb.setCaption("About  Qt-BSch");
	mb.setTextFormat(RichText);
	mb.setText(	
			"<center><b>Qt-BSch mac  Version 0.11d</b><br><br>"
			"Copyright(C) 2002-2003 H.Okada(Suigyodo)<br>"
			"Qt-BSch comes with absolutely no warranty.<br>"
			"URL  http://www.suigyodo.com/online<br>"
			"E-Mail  hitoshi@suigyodo.com</center>"
		);
	mb.setIconPixmap(icon);
	//mb.adjustSize();
	mb.exec();
}


void ApplicationWindow::aboutQt()
{
    QMessageBox::aboutQt( this, "About Qt" );
}

//EDIT
void ApplicationWindow::EditUndo()
{
	m_pXBSchView->undo();

//	qDebug("void ApplicationWindow::EditUndo()\n");
}
void ApplicationWindow::EditCut()
{
	m_pXBSchView->cut();
}
void ApplicationWindow::EditCopy()
{
	printf("EditCopy()\n");
	m_pXBSchView->copy();
}
void ApplicationWindow::EditPaste()
{
	m_pXBSchView->paste();
}
void ApplicationWindow::EditDelete()
{
	m_pXBSchView->del();
}
void ApplicationWindow::EditAttr()
{
	m_pXBSchView->attribute();
}

void ApplicationWindow::EditMirror()
{
	m_pXBSchView->mirror();
}
void ApplicationWindow::EditRotate()
{
	m_pXBSchView->rotate();
}
void ApplicationWindow::EditInvert()
{
}
//VIEW
void ApplicationWindow::ViewRefresh()
{
	m_pXBSchView->RefreshView();
}

void ApplicationWindow::ZoomIn(bool menucommand)
{
	m_pXBSchView->ZoomIn(menucommand);
	menuBar()->setItemEnabled(m_nMenuIdViewZoomOut,m_pXBSchView->CanZoomOut());
	menuBar()->setItemEnabled(m_nMenuIdViewZoomIn,m_pXBSchView->CanZoomIn());
}
void ApplicationWindow::ZoomOut(bool menucommand)
{
	m_pXBSchView->ZoomOut(menucommand);
	menuBar()->setItemEnabled(m_nMenuIdViewZoomOut,m_pXBSchView->CanZoomOut());
	menuBar()->setItemEnabled(m_nMenuIdViewZoomIn,m_pXBSchView->CanZoomIn());
}


void ApplicationWindow::ViewZoomIn()
{
	ZoomIn(true);
}
void ApplicationWindow::ViewZoomOut()
{
	ZoomOut(true);
}

void ApplicationWindow::ViewGridOnOff()
{
	bool bGridOn =!(menuBar()->isItemChecked(m_nMenuIdViewGrid));
	menuBar()->setItemChecked(m_nMenuIdViewGrid,bGridOn);
	m_pXBSchView->setDisplayGrid(bGridOn);
	g_cfg.setInt("VIEW","GRID",bGridOn);
}

//TOOL
void ApplicationWindow::ToolSelector()
{
	//qDebug("void ApplicationWindow::ToolSelector()");
	m_pXBSchView->setToolMode(TOOL_SELECTOR);
	SetToolButtonState();
}

void ApplicationWindow::ToolDrag()
{
	m_pXBSchView->setToolMode(TOOL_DRAG);
	SetToolButtonState();
}
void ApplicationWindow::ToolComp()
{
	m_pXBSchView->setToolMode(TOOL_COMPONENT);
	SetToolButtonState();
}
void ApplicationWindow::ToolBus()
{
	m_pXBSchView->setToolMode(TOOL_BUS);
	SetToolButtonState();
}
void ApplicationWindow::ToolWire()
{
	m_pXBSchView->setToolMode(TOOL_WIRE);
	SetToolButtonState();
}
void ApplicationWindow::ToolDash()
{
	m_pXBSchView->setToolMode(TOOL_DASH);
	SetToolButtonState();
}
void ApplicationWindow::ToolJunction()
{
	m_pXBSchView->setToolMode(TOOL_JUNCTION);
	SetToolButtonState();
}
void ApplicationWindow::ToolBEntry()
{
	m_pXBSchView->setToolMode(TOOL_BENTRY);
	SetToolButtonState();
}
void ApplicationWindow::ToolEntry()
{
	m_pXBSchView->setToolMode(TOOL_ENTRY);
	SetToolButtonState();
}
void ApplicationWindow::ToolTag()
{
	m_pXBSchView->setToolMode(TOOL_TAG);
	SetToolButtonState();
}
void ApplicationWindow::ToolLabel()
{
	m_pXBSchView->setToolMode(TOOL_LABEL);
	SetToolButtonState();
}
void ApplicationWindow::ToolCmnt()
{
	m_pXBSchView->setToolMode(TOOL_COMMENT);
	SetToolButtonState();
}

//SET
void ApplicationWindow::SetSheetSize()
{
	m_pXBSchView->resize();
}


//ӥ塼ǤΥ֤ΰư
void ApplicationWindow::cursorMove(int x,int y)
{
	char buff[16];
	sprintf(buff," X:%04d ",x);
	m_plabelX->setText(buff);
	sprintf(buff," Y:%04d ",y);
	m_plabelY->setText(buff);
}

//ӥ塼ǤΥġζѹξ
void ApplicationWindow::toolChange()
{
	//printf("ApplicationWindow::toolChange()\n");
	SetToolButtonState();
}


//Window˥塼Υߥ󥰤
void ApplicationWindow::setupWindowMenu()
{
	//printf("setupWindowMenu \n");
	QString fn;
	m_menuWindow->clear();
	int windowCount=m_appWindowList.count();
	int n;
	for(n=0;n<windowCount;n++){
		ApplicationWindow * w = (ApplicationWindow*)m_appWindowList.at(n);
		fn=w->fileName();
		if(fn.isEmpty()) fn="Untitled";
		m_menuWindow->insertItem(fn,n);
		if(w==this){
			m_menuWindow->setItemChecked(n,true);
		}
    }
	

}

//Window˥塼Υƥब򤵤줿ȤSLOT
void ApplicationWindow::selectActiveDocument(int id)
{
	int windowCount=m_appWindowList.count();
	if(id<0 || windowCount<=id)return;
	ApplicationWindow * w = (ApplicationWindow*)m_appWindowList.at(id);
	w->setActiveWindow();
}

void ApplicationWindow::SetSnap()
{
	bool bCheck =!(menuBar()->isItemChecked(m_nMenuIdSetSnap));
	menuBar()->setItemChecked(m_nMenuIdSetSnap,bCheck);
	m_pXBSchView->setSnapGrid(bCheck);
	g_cfg.setInt("SET","SNAP",bCheck);
}

//饤֥Ԥ
void ApplicationWindow::SetLibrary()
{
	QStringList list;
	int n;
	char szKey[32];
	string filename;
	for(n=0;n<MAX_LIB;n++){
		sprintf(szKey,"LIB%d",n);
		if(g_cfg.getString("Library",szKey,filename)){
			list.append(QString::fromLocal8Bit(filename.c_str()));
		}else{
			break;
		}
	}
	SetLib* dlg=new SetLib(this,0,true);
	dlg->setFiles(list);
	if(dlg->exec()){
		//qDebug("void ApplicationWindow::SetLibrary() OK\n");
		list.clear();
		list=dlg->selectedFiles();
		QStringList::Iterator it = list.begin();
		for(n=0;n<MAX_LIB;n++){
			sprintf(szKey,"LIB%d",n);
			if(it != list.end()){
				if(!(*it).isEmpty()){
					string strData = string((*it).local8Bit());
					g_cfg.setString("Library",szKey,strData);
				}else{
					g_cfg.setString("Library",szKey,"");
				}
				it++;
			}else{
				g_cfg.setString("Library",szKey,"");
			}
		}
		delete dlg;
		QMessageBox::information( this, "Set Library",
								"You must restart Qt BSch before\nthe new settings will take effect.",
								"OK",QString::null,QString::null,0,0);
	}else{
		delete dlg;
	}
}
void ApplicationWindow::SetFont()
{
	QFont font;
	string strname;
	if(g_cfg.getString("Font","Name",strname)){
		font=QFont(QString::fromLocal8Bit(strname.c_str()));
		int n;
		if(g_cfg.getInt("Font","Size",n)) font.setPixelSize(n);
		if(g_cfg.getInt("Font","Bold",n)) font.setBold(n!=0);
		if(g_cfg.getInt("Font","Italic",n)) font.setItalic(n!=0);
		if(g_cfg.getInt("Font","Underline",n)) font.setStrikeOut(n!=0);
		if(g_cfg.getInt("Font","StrikeOut",n)) font.setUnderline(n!=0);
	}		

	bool ok;
	font=QFontDialog::getFont(&ok,font,this);
	if(ok){
		g_cfg.setString("Font","Name",string(font.family().local8Bit()));
		QFontInfo fontInfo(font);
		g_cfg.setInt("Font","Size",fontInfo.pixelSize());
		g_cfg.setInt("Font","Bold",font.bold()?1:0);
		g_cfg.setInt("Font","Italic",font.italic()?1:0);
		g_cfg.setInt("Font","Underline",font.underline()?1:0);
		g_cfg.setInt("Font","StrikeOut",font.strikeOut()?1:0);
		m_pXBSchView->setDefaultFont();
	}
}

//ġΥܥξ֤ȥ˥塼Υå֤ꤹ
void ApplicationWindow::SetToolButtonState()
{
	BSCH_TOOL_MODE toolmode = m_pXBSchView->toolMode();
	//˥塼Υå
	menuBar()->setItemChecked(m_nMenuIdToolSelect,toolmode == TOOL_SELECTOR);
    menuBar()->setItemChecked(m_nMenuIdToolDrag,toolmode == TOOL_DRAG);
    menuBar()->setItemChecked(m_nMenuIdToolComp,toolmode == TOOL_COMPONENT);
    menuBar()->setItemChecked(m_nMenuIdToolBus,toolmode == TOOL_BUS);
    menuBar()->setItemChecked(m_nMenuIdToolWire,toolmode == TOOL_WIRE);
    menuBar()->setItemChecked(m_nMenuIdToolDash,toolmode == TOOL_DASH);
    menuBar()->setItemChecked(m_nMenuIdToolJunc,toolmode == TOOL_JUNCTION);
    menuBar()->setItemChecked(m_nMenuIdToolBEnt,toolmode == TOOL_BENTRY);
	menuBar()->setItemChecked(m_nMenuIdToolEnt,toolmode == TOOL_ENTRY);
	menuBar()->setItemChecked(m_nMenuIdToolTag,toolmode == TOOL_TAG);
	menuBar()->setItemChecked(m_nMenuIdToolLabel,toolmode == TOOL_LABEL);
	menuBar()->setItemChecked(m_nMenuIdToolCmnt,toolmode == TOOL_COMMENT);
	//ġСΥܥξ
	m_ptbToolSelect->setOn(toolmode == TOOL_SELECTOR);
    m_ptbToolDrag->setOn(toolmode == TOOL_DRAG);
    m_ptbToolComp->setOn(toolmode == TOOL_COMPONENT);
    m_ptbToolBus->setOn(toolmode == TOOL_BUS);
    m_ptbToolWire->setOn(toolmode == TOOL_WIRE);
    m_ptbToolDash->setOn(toolmode == TOOL_DASH);
    m_ptbToolJunc->setOn(toolmode == TOOL_JUNCTION);
    m_ptbToolBEnt->setOn(toolmode == TOOL_BENTRY);
	m_ptbToolEnt->setOn(toolmode == TOOL_ENTRY);
	m_ptbToolTag->setOn(toolmode == TOOL_TAG);
	m_ptbToolLabel->setOn(toolmode == TOOL_LABEL);
	m_ptbToolCmnt->setOn(toolmode == TOOL_COMMENT);
}

//ץꥱΥץ
void ApplicationWindow::setAppCaption()
{
	QString caption = "Qt BSch - ";
	caption += m_filename;
#ifdef _WINDOWS
	HWND hw = winId();
	char szCaption[300];
	strcpy(szCaption,caption.local8Bit());
	::SetWindowText(hw,szCaption);
	topData()->caption = caption;
#else
	setCaption( caption );
#endif
}

