// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef EDITCOMMENT_H
#define EDITCOMMENT_H
#include "editcomment.h"

class editcomment : public editcommentBase
{ 
    Q_OBJECT


public:
    editcomment( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~editcomment();

	int exec();

	void fontbuttonClicked();
	void setFont(QFont& fn){ m_font = fn; }
	QFont font(){return m_font;}
	void setText(const QString& text);
	QString text();

protected  slots:
	void accept();

protected:
	QFont m_font;
	QString m_text;
	
};

#endif // EDITCOMMENT_H
