// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef EDITCOMPONENT_H
#define EDITCOMPONENT_H
#include "editcomponent.h"

class SCompIndex;

class editcomponent : public editcomponentBase
{ 
    Q_OBJECT

public:
    editcomponent( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~editcomponent();
	int exec();
	void setName(const QString& text){m_strName = text;}
	void setReference(const QString& text){m_strReference = text;}
	void setOrgName(const QString& text){m_orgName = text;}
	QString name()const{return m_strName;}
	QString reference()const{return m_strReference;}
	QString orgName()const{return m_orgName;}
	void setBlock(int block){m_block = block;}
	int block()const{return m_block;}
	void setCompIndex(const SCompIndex* pIndex);

protected  slots:
	void accept();
	void blockChanged(int);

protected:
	void setPinNum(int block);

protected:
	QString m_strName;
	QString m_strReference;
	QString m_orgName;
	int m_block;
	int m_maxblock;

	const SCompIndex* m_compInfoIndex;
};

#endif // EDITCOMPONENT_H
