// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef SELCOMP_H
#define SELCOMP_H
#include "selcomp.h"

#include <string>

#include "componentview.h"

using namespace std;
class SCompIndex;

class SelComp : protected selcompBase
{ 
    Q_OBJECT

protected:
	SComponentView* ComponentView;

    void libraryChanged();
    void componentChanged();
	void setLibraryName();
	void setComponentName(int nLib);

	string m_strComponentName;
	int m_nLib;
	int m_nIndex;
	const SCompIndex* m_pCompIndex;


public:
    SelComp( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~SelComp();
	
	int exec();
	const SCompIndex* selectedCompIndex() const{return m_pCompIndex;}
	int selectedCompLibNum() const{return m_nLib;}
	int selectedCompIndexNum() const{return m_nIndex;}

protected:
	void accept();
};

#endif // SELCOMP_H
